﻿// -----------------------------------------------------------------------
//  <copyright file="UserRoleInputDtoBase.cs" company="OSharp开源团队">
//      Copyright (c) 2014-2020 OSharp. All rights reserved.
//  </copyright>
//  <site>http://www.osharp.org</site>
//  <last-editor>郭明锋</last-editor>
//  <last-date>2020-01-31 19:21</last-date>
// -----------------------------------------------------------------------

using OSharp.Entity;


namespace OSharp.Identity.Dtos
{
    /// <summary>
    /// 用户角色输入DTO基类
    /// </summary>
    public abstract class UserRoleInputDtoBase<TKey, TUserKey, TRoleKey> : IInputDto<TKey>
    {
        /// <summary>
        /// 获取或设置 用户编号
        /// </summary>
        public TUserKey UserId { get; set; }

        /// <summary>
        /// 获取或设置 角色编号
        /// </summary>
        public TRoleKey RoleId { get; set; }

        /// <summary>
        /// 获取或设置 是否锁定
        /// </summary>
        public bool IsLocked { get; set; }

        /// <summary>
        /// 获取或设置 主键，唯一标识
        /// </summary>
        public TKey Id { get; set; }
    }
}